::--------------------------------
::-- Main
::================================

:: SETTINGS
:: -----------------------
@echo off
set PATHPACKAGE='%~dp0'
echo Working directory: %PATHPACKAGE%
SETLOCAL EnableDelayedExpansion
for /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & echo on & for %%b in (1) do rem"') do (
  set "DEL=%%a"
)


:: REMOVING UNWANTED FILES
:: -----------------------
echo.
echo [PREPARE FOR PACKAGE CHECK]
echo.
:: 

echo -^> Clean RLumModel.BuildResults folder ...
find %PATHPACKAGE%\RLumModel.BuildResults\ -type f -delete
call :check

::echo -^> Remove NAMESPACE ...
::find %PATHPACKAGE% -name NAMESPACE -delete
::call :check

:: roxygen2
:: -----------------------
echo -^> Create empty NAMESPACE file ...
echo # Generated by roxygen2 (4.1.0.9001): do not edit by hand > NAMESPACE
call :check

echo -^> Build documentation ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_roxygen2.R" NULL
call :check

:: COMPILE FUNCTION PARAMTER LIST
:: -----------------------
echo -^> Compile function argument list ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_Function_Arguments.R" NULL
call :check

:: NEWS
:: -----------------------
echo -^> Build ASCII NEWS ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_NEWS.R" NULL
call :check

echo -^> Remove output dump ...
find %PATHPACKAGE% -name NULL -delete
call :check

:: BUILD PACKAGE
:: -----------------------
echo.
echo [BUILD PACKAGE]
echo.

R CMD build "%PATHPACKAGE:'=%"

:: CHECK PACKAGE
:: -----------------------
echo.
echo [CHECK PACKAGE]
echo.
R CMD check --timings "%PATHPACKAGE:'=%\RLumModel*.tar.gz"

echo Example timing warnings ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_Timings.R" NULL
type %PATHPACKAGE%\RLumModel.BuildResults\*.WARNING

:: INSTALL PACKAGE
:: -----------------------
echo.
echo [INSTALL PACKAGE]
echo.
R CMD INSTALL --build "%PATHPACKAGE:'=%\RLumModel*.tar.gz"


:: COPY FILES AND CLEANING UP
:: -----------------------
echo.
echo [COPY FILES AND CLEANING UP]
echo.

echo -^> Write BibTeX ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_BibTeX.R" NULL
call :check

echo -^> Build function list ...
R CMD BATCH --no-timing "%PATHPACKAGE:'=%\RLumModel.BuildScripts\RLumModel.PBS_Function_List.R" NULL
call :check

echo -^> Moving packge source files (^*.tar.gz)
mv RLumModel_*.tar.gz RLumModel.BuildResults\
call :check

echo -^> Moving packge source files (^*.zip)
mv RLumModel_*.zip RLumModel.BuildResults\
call :check

echo -^> ^Copy manual ...
copy "%PATHPACKAGE:'=%\RLumModel.Rcheck\RLumModel-manual.pdf" "%PATHPACKAGE:'=%\RLumModel.BuildResults\RLumModel-manual.pdf"
call :check

echo -^> ^Copy check results ...
copy "%PATHPACKAGE:'=%\RLumModel.Rcheck\RLumModel-Ex.pdf" "%PATHPACKAGE:'=%\RLumModel.BuildResults\RLumModel-Ex.pdf"
call :check

echo -^> Remove Luminescence.Rcheck ...
rm -rf %PATHPACKAGE%\RLumModel.Rcheck
call :check

echo -^> Remove output dump ...
find %PATHPACKAGE% -name NULL -delete
call :check

echo -^> Remove .Rdata ...
find %PATHPACKAGE% -name .Rdata -delete
call :check

echo -^> Remove .Rhistory ...
find %PATHPACKAGE% -name .Rhistory -delete
call :check

echo.
echo [DONE]

pause
goto :eof
::--------------------------------
::-- Functions
::--------------------------------

:: From NiklasJ @SO (http://stackoverflow.com/questions/7923948/batch-color-per-line)
:ColorText
echo off
<nul set /p ".=%DEL%" > "%~2"
findstr /v /a:%1 /R "^$" "%~2" nul
del "%~2" > nul 2>&1
goto :eof

:: %errorlevel% 0 = success, 1 = fail, 2 = unknown
:check
IF %errorlevel% == 0 (
	call :ColorText 0a "  [OK]"
	echo.
	)
IF %errorlevel% == 1 (
	call :ColorText 0C "  [FAIL]"
	echo.
	)
IF %errorlevel% == 2 (
	call :ColorText 0b "  [UNKNOWN ERROR]"
	echo.
	)
goto :eof
